; add model procedures here
breeds [a b d m p s v w]
globals [

former-a
former-b
former-d
former-m
former-p
former-s
former-v
former-w

coorx-a
coory-a
coorx-b
coory-b
coorx-d
coory-d
coorx-m
coory-m
coorx-p
coory-p
coorx-s
coory-s
coorx-v
coory-v
coorx-w
coory-w

dist1-ab
dist1-ad
dist1-am
dist1-ap
dist1-as
dist1-av
dist1-aw

dist2-ab
dist2-ad
dist2-ap
dist2-am
dist2-as
dist2-av
dist2-aw


dist2-a

dist1-ba
dist1-bd
dist1-bm
dist1-bp
dist1-bs
dist1-bv
dist1-bw

dist2-ba
dist2-bd
dist2-bm
dist2-bp
dist2-bs
dist2-bv
dist2-bw


dist2-b

dist1-da
dist1-db
dist1-dm
dist1-dp
dist1-ds
dist1-dv
dist1-dw

dist2-da
dist2-db
dist2-dm
dist2-dp
dist2-ds
dist2-dv
dist2-dw

dist2-d

dist1-ma
dist1-mb
dist1-md
dist1-mp
dist1-ms
dist1-mv
dist1-mw

dist2-ma
dist2-mb
dist2-md
dist2-mp
dist2-ms
dist2-mv
dist2-mw

dist2-m

dis-a-b
dis-a-d
dis-a-m
dis-a-p

dis-b-a
dis-b-d
dis-b-m
dis-b-p

dis-d-a
dis-d-b
dis-d-m
dis-d-p

dis-m-a
dis-m-b
dis-m-d
dis-m-p

dist2-p

dist1-pa
dist1-pb
dist1-pd
dist1-pm
dist1-ps
dist1-pv
dist1-pw

dist2-pa
dist2-pb
dist2-pd
dist2-pm
dist2-ps
dist2-pv
dist2-pw

dis-p-a
dis-p-b
dis-p-d
dis-p-m
dis-p-s
dis-p-v
dis-p-w


aver
]


to setup
ca
set dis-a-b affection-a-b
set dis-a-d affection-a-d
set dis-a-m affection-a-m
set dis-a-p affection-a-p

set dis-b-a affection-b-a
set dis-b-d affection-b-d
set dis-b-m affection-b-m
set dis-b-p affection-b-p

set dis-d-a affection-d-a
set dis-d-b affection-d-b
set dis-d-m affection-d-m
set dis-d-p affection-d-p

set dis-m-a affection-m-a
set dis-m-b affection-m-b
set dis-m-d affection-m-d
set dis-m-p affection-m-p

set dis-p-a affection-p-a
set dis-p-b affection-p-b
set dis-p-d affection-p-d
set dis-p-m affection-p-m


create-custom-a 1 [set former-a 0 setxy random screen-size-x random screen-size-y set color blue set shape "box"
set coorx-a xcor set coory-a ycor]
create-custom-b 1 [set former-b 0 setxy random screen-size-x random screen-size-y set color red set shape "box"
set coorx-b xcor set coory-b ycor]
create-custom-d 1 [set former-d 0 setxy random screen-size-x random screen-size-y set color green set shape "box"
set coorx-d xcor set coory-d ycor]
create-custom-m 1 [set former-m 0 setxy random screen-size-x random screen-size-y set color magenta set shape "box"
set coorx-m xcor set coory-m ycor]
create-custom-p 1 [set former-p 0 setxy random screen-size-x random screen-size-y set color brown set shape "box"
set coorx-p xcor set coory-p ycor]

end


to calculate-a
set dist1-ab  (coorx-a - coorx-b) ^ 2 + (coory-a - coory-b) ^ 2
set dist1-ad  (coorx-a - coorx-d) ^ 2 + (coory-a - coory-b) ^ 2
set dist1-am  (coorx-a - coorx-m) ^ 2 + (coory-a - coory-m) ^ 2
set dist1-ap  (coorx-a - coorx-p) ^ 2 + (coory-a - coory-p) ^ 2
set dist2-ab  sqrt(dist1-ab)
set dist2-ad  sqrt(dist1-ad)
set dist2-am  sqrt(dist1-am)
set dist2-ap  sqrt(dist1-ap)
set dist2-a  abs(dis-a-b - dist2-ab) + abs(dis-a-d - dist2-ad) + abs(dis-a-m - dist2-am) + abs(dis-a-p + dist2-ap)
if dist2-a < former-a  [set xcor coorx-a  set ycor coory-a ]
end



to calculate-b
set dist1-ba  (coorx-b - coorx-a) ^ 2 + (coory-b - coory-a) ^ 2
set dist1-bd  (coorx-b - coorx-d) ^ 2 + (coory-b - coory-d) ^ 2
set dist1-bm  (coorx-b - coorx-m) ^ 2 + (coory-b - coory-m) ^ 2
set dist1-bm  (coorx-b - coorx-p) ^ 2 + (coory-b - coory-p) ^ 2
set dist2-ba  sqrt(dist1-ba)
set dist2-bd  sqrt(dist1-bd)
set dist2-bm  sqrt(dist1-bm)
set dist2-bp  sqrt(dist1-bp)
set dist2-b abs(dis-b-a - dist2-ba) + abs(dis-b-d - dist2-bd) + abs(dis-b-m - dist2-bd) + abs(dis-b-p - dist2-bp)
end

to calculate-d
set dist1-da  (coorx-d - coorx-a) ^ 2 + (coory-d - coory-a) ^ 2
set dist1-db  (coorx-d - coorx-b) ^ 2 + (coory-d - coory-b) ^ 2
set dist1-dm  (coorx-d - coorx-m) ^ 2 + (coory-d - coory-m) ^ 2
set dist1-dp  (coorx-d - coorx-p) ^ 2 + (coory-d - coory-p) ^ 2
set dist2-da  sqrt(dist1-da)
set dist2-db  sqrt(dist1-db)
set dist2-dm  sqrt(dist1-dm)
set dist2-dp  sqrt(dist1-dp)
set dist2-d abs(dis-d-a - dist2-da) + abs(dis-d-b - dist2-db) + abs(dis-d-m - dist2-bm) + abs(dis-d-p - dist2-dp)
end

to calculate-m
set dist1-ma  (coorx-m - coorx-a) ^ 2 + (coory-m - coory-a) ^ 2
set dist1-mb  (coorx-m - coorx-b) ^ 2 + (coory-m - coory-b) ^ 2
set dist1-md  (coorx-m - coorx-d) ^ 2 + (coory-m - coory-d) ^ 2
set dist1-mp  (coorx-m - coorx-p) ^ 2 + (coory-m - coory-p) ^ 2
set dist2-ma  sqrt(dist1-ma)
set dist2-mb  sqrt(dist1-mb)
set dist2-md  sqrt(dist1-md)
set dist2-mp  sqrt(dist1-mp)
set dist2-m abs(dis-m-a - dist2-ma) + abs(dis-m-b - dist2-mb) + abs(dis-m-d - dist2-md) + abs(dis-m-p - dist2-mp)
end

to calculate-p
set dist1-pa  (coorx-p - coorx-a) ^ 2 + (coory-p - coory-a) ^ 2
set dist1-pb  (coorx-p - coorx-b) ^ 2 + (coory-p - coory-b) ^ 2
set dist1-pd  (coorx-p - coorx-d) ^ 2 + (coory-p - coory-d) ^ 2
set dist1-pm  (coorx-p - coorx-m) ^ 2 + (coory-p - coory-m) ^ 2
set dist2-pa  sqrt(dist1-pa)
set dist2-pb  sqrt(dist1-pb)
set dist2-pd  sqrt(dist1-pd)
set dist2-pm  sqrt(dist1-pm)
set dist2-m abs(dis-p-a - dist2-pa) + abs(dis-p-b - dist2-pb) + abs(dis-p-d - dist2-pd) + abs(dis-p-m - dist2-pm)
end

to calculate-new-coord-a
if dist2-a < former-a  [set xcor coorx-a set ycor coory-a]
end

to calculate-new-coord-b
if dist2-b < former-b [ set xcor coorx-b set ycor coory-b]
end

to calculate-new-coord-d
if dist2-d < former-d [set xcor coorx-d set ycor coory-d]
end

to calculate-new-coord-m
if dist2-m < former-m [set xcor coorx-m set ycor coory-m]
end

to calculate-new-coord-p
if dist2-m < former-p [set xcor coorx-p set ycor coory-p]
end

to average
set aver (dist2-a + dist2-b + dist2-d + dist2-m + dist2-p) / 5
end

to plotter
set-current-plot "average distance amoung four agents"
plot aver
end

to go

ask a [fd 0.5 rt random 90 lt random 90 calculate-a calculate-new-coord-a set coorx-a xcor set coory-a ycor set former-a dist2-a ]
ask b [fd 0.5  rt random 90 lt random 90 calculate-b calculate-new-coord-b set coorx-b xcor set coory-b ycor set former-b dist2-b]
ask d [fd 0.5  rt random 90 lt random 90 calculate-d calculate-new-coord-d set coorx-d xcor set coory-d ycor set former-d dist2-d]
ask m [fd 0.5  rt random 90 lt random 90 calculate-m calculate-new-coord-m set coorx-m xcor set coory-m ycor set former-m dist2-m]
ask p [fd 0.5  rt random 90 lt random 90 calculate-p calculate-new-coord-p set coorx-p xcor set coory-p ycor set former-p dist2-p]
average
plotter
end
@#$#@#$#@
GRAPHICS-WINDOW
164
10
405
272
14
14
7.97
1
10
1
1
1
0

CC-WINDOW
5
574
855
669
Command Center

BUTTON
48
48
111
81
NIL
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
48
85
111
118
NIL
go
T
1
T
OBSERVER
T
NIL

PLOT
3
153
163
303
average distance amoung four agents
NIL
NIL
0.0
10.0
0.0
10.0
true
false

TEXTBOX
30
346
180
436
a=blue\nb=red\nd=green\nm=magenta\np=brown

SLIDER
484
10
656
43
affection-a-b
affection-a-b
-100
100
100
1
1
NIL

SLIDER
484
44
656
77
affection-a-d
affection-a-d
-100
100
100
1
1
NIL

SLIDER
484
77
656
110
affection-a-m
affection-a-m
-100
100
100
1
1
NIL

SLIDER
484
110
656
143
affection-a-p
affection-a-p
-100
100
100
1
1
NIL

SLIDER
484
152
656
185
affection-b-a
affection-b-a
-100
100
100
1
1
NIL

SLIDER
485
185
657
218
affection-b-d
affection-b-d
-100
100
100
1
1
NIL

SLIDER
485
217
657
250
affection-b-m
affection-b-m
-100
100
100
1
1
NIL

SLIDER
485
250
657
283
affection-b-p
affection-b-p
-100
100
100
1
1
NIL

SLIDER
486
428
658
461
affection-m-a
affection-m-a
-100
100
100
1
1
NIL

SLIDER
486
461
658
494
affection-m-b
affection-m-b
-100
100
100
1
1
NIL

SLIDER
486
494
658
527
affection-m-d
affection-m-d
-100
100
100
1
1
NIL

SLIDER
486
527
658
560
affection-m-p
affection-m-p
-100
100
100
1
1
NIL

SLIDER
674
10
846
43
affection-p-a
affection-p-a
-100
100
-100
1
1
NIL

SLIDER
674
42
846
75
affection-p-b
affection-p-b
-100
100
-100
1
1
NIL

SLIDER
674
75
846
108
affection-p-m
affection-p-m
-100
100
-100
1
1
NIL

SLIDER
674
108
846
141
affection-p-d
affection-p-d
-100
100
-100
1
1
NIL

SLIDER
487
292
659
325
affection-d-a
affection-d-a
-100
100
100
1
1
NIL

SLIDER
487
324
659
357
affection-d-b
affection-d-b
-100
100
100
1
1
NIL

SLIDER
487
357
659
390
affection-d-m
affection-d-m
-100
100
100
1
1
NIL

SLIDER
487
390
659
423
affection-d-p
affection-d-p
-100
100
100
1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
Title: Social dance in cyber space.
This program was develop by A.K. Dewdney's idea in Scientific American. Hew described a algorihtm about how the people can organize their space between them in a digital party. In behavioral science it is important point of proximity space of people. Some people have more or less tolerable space. How can we model this proximity index? We can use Dewdney algorihtm. Each people in digital party have a ideal distance again other people. Program calculates the concret distance between a given agent and other agents. If the summa of these distances are less as the former distance in former iteration than agent moves to the xy coordinate of this distance.

HOW IT WORKS
------------
dis-*-* is the ideal distance between the given agents.
dist1-** distance between two agents
dist2-** is sqrt(dist1-**)
next computed total space is summa of absolute value of given dist2's.
If next distance is better than the former the agent will move to this coordinates.

HOW TO USE IT
-------------
You can modify the affection distance between agents in sliders.
-100 value represent agnet's hate again other agent.
100 value: agent has very love other agent.



EXTENDING THE MODEL
-------------------
Let's try find some ideal distances.



CREDITS AND REFERENCES
----------------------
Simulation was written by Kazmer Karadi, Institute of Behavioral Sciences, Faculty of Medicine, Univeristy of Pcs, Pcs, Szigeti u.12. H-7624, kazmerkaradi@hotmail.com
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

line
true
0
Line -7566196 true 150 0 150 300

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7566196 true true 15 105 105 165
Rectangle -7566196 true true 45 90 105 105
Polygon -7566196 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7566196 true true 105 120 263 195
Rectangle -7566196 true true 108 195 259 201
Rectangle -7566196 true true 114 201 252 210
Rectangle -7566196 true true 120 210 243 214
Rectangle -7566196 true true 115 114 255 120
Rectangle -7566196 true true 128 108 248 114
Rectangle -7566196 true true 150 105 225 108
Rectangle -7566196 true true 132 214 155 270
Rectangle -7566196 true true 110 260 132 270
Rectangle -7566196 true true 210 214 232 270
Rectangle -7566196 true true 189 260 210 270
Line -7566196 true 263 127 281 155
Line -7566196 true 281 155 281 192

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.1beta2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
