breeds [fishes stones bubbles eyes rays virfish]

globals
[
  time
  eye
  fish
]
rays-own [aa ab]
to setup
  ca
  ask patches with [pycor <= 0]
  [
    set pcolor blue
  ]
  set eye []
  set fish []
  set time 0
  set-default-shape rays "line"
end

to go
  no-display
  set time time + 1
  swim
  ask rays[die]
  ask virfish[die]
  see
  display
end

to swim
  ask patches with[pycor = 0]
  [set pcolor blue]
  ask bubbles
  [
    fd 4
    if ycor >= 0
    [die]
  ]

  ask fishes
  [
    if ycor < 0
    [
      set pcolor-of patch-at 0 1 107
    ]
    ifelse abs xcor > screen-edge-x - 9
    [
      ifelse xcor < 0
      [set heading 90]
      [set heading 270]
    ]

    [
      if abs xcor > screen-edge-y - 7
      [
        set ycor ycor - 2
      ]
      if ycor > 0
        [set ycor -1]
      if random 10 = 1
      [set heading heading + 180]
      if random 1 = 0
      [
        ifelse random 2 = 1
        [if ycor < -2 [set ycor ycor + 1]]
        [set ycor ycor - 1]
      ]
    ]
    fd 3
    ifelse heading = 90
    [set shape "fish"]
    [set shape "left_fish"]
  ]
  ask stones
  [
    ifelse ycor < 0 and abs ycor > (screen-edge-y - 7)
    [
      set ycor (-1 * screen-edge-y + 6)
    ]
    [fd 3]
  ]
  ask patches with [pcolor = 107]
  [
    set pcolor blue
    if time mod 2 = 0
    [
      sprout-bubbles 1
      [
        set size 1
        set color 87
        set heading 0
        set shape "circle"
      ]
    ]
  ]
end

to make-fish
  cct-fishes 1
  [
    set fish fput self fish
    set color 47
    set shape "fish"
    setxy ((random (2 * screen-edge-x) ) - screen-edge-x) -1 * (random screen-edge-y + 3)
    set size 4
    set heading 90
  ]
end

to throw-stone
  cct-stones 1
  [
    set shape "circle"
    set color 36
    setxy ((2 * random (screen-edge-x - 6 ) ) - (screen-edge-x - 6) ) random screen-edge-y
    set size 5
    set heading 180
  ]
end

to make-eyes
  cct-eyes 1
  [
    set eye fput self eye
    setxy ((random (2 * (screen-edge-x - 8)) ) - (screen-edge-x - 8)) (random (screen-edge-y - 12)) + 8
    set shape "face happy"
    set size 5
    set color 36.5
  ]
end

to see
  let fi 0
  let ey 0
  let tmp []
  let lasta 0
  let lastb 0
  without-interruption
  [
    ask fishes
    [
      set fi self
      without-interruption
      [
        ask eyes
        [
          set ey self
          let x round min list xcor-of ey xcor-of fi
          let m round max list xcor-of ey xcor-of fi
          let a 0
          let b 0
          let min-yet 999
          let val x
          while [x <= m]
          [
            set a towardsxy-nowrap x 0
            ask patch x 0
            [
;              set pcolor yellow
              set b towards-nowrap fi
            ]
            if abs (n1 * sin a - n2 * sin b) < min-yet
            [
              set val x
              set lasta a
              set lastb b
              set min-yet abs (n1 * sin a - n2 * sin b)
            ]
            set x x + 1
          ]
;          ask patch round val 0 [set pcolor red]
          set tmp fput (list ey patch round val 0 fi lasta) tmp
        ]
      ]
    ]
  ]
  foreach tmp
  [
    makevirfish item 0 ? item 1 ? item 2 ? item 3 ?
    make-start item 0 ? item 1 ? item 2 ?
  ]
end

to makevirfish [i p fi a]
  let tmp 0
  cct-virfish 1
  [
    set tmp self
    set heading heading-of fi
    set shape shape-of fi
    set xcor xcor-of fi
    set color 66
    set size 4
    set ycor -1 * abs( (pxcor-of p - xcor) * (cos a / sin a))
  ]
  cct-rays 1
  [
    set color 78
    setxy (xcor-of i) (ycor-of i)
    set size distance-nowrap tmp
    if size > 0
    [set heading towards-nowrap tmp]
    jump size / 2
  ]
end

to make-start[i p f]
  cct-rays 1
  [
    set color green
    setxy (xcor-of i) (ycor-of i)
    set size distancexy-nowrap pxcor-of p pycor-of p
    if size > 0
    [set heading towardsxy-nowrap pxcor-of p pycor-of p]
    jump size / 2
  ]
  cct-rays 1
  [
    set color green
    setxy (pxcor-of p) (pycor-of p)
    set size distance-nowrap f
    if size > 0
    [set heading towards-nowrap f]
    jump size / 2
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
204
10
618
445
50
50
4.0
1
10
1
1
1
0
1
1
1

CC-WINDOW
5
553
627
648
Command Center
0

BUTTON
67
83
130
116
NIL
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
70
135
133
168
NIL
go
T
1
T
OBSERVER
T
NIL

BUTTON
65
189
150
222
Make fish
make-fish
NIL
1
T
OBSERVER
T
NIL

BUTTON
51
282
154
315
Throw stone
throw-stone
NIL
1
T
OBSERVER
T
NIL

BUTTON
33
360
104
393
pop'em
make-eyes
NIL
1
T
OBSERVER
T
NIL

BUTTON
113
358
182
391
NIL
see\n
NIL
1
T
OBSERVER
T
NIL

SLIDER
27
451
199
484
n1
n1
0
2
1.0
0.1
1
NIL

SLIDER
63
506
235
539
n2
n2
0
2
1.5
0.1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 30 30 240

circle 2
false
0
Circle -7566196 true true 16 16 270
Circle -16777216 true false 46 46 210

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7566196 true true 30 30 240

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11030470 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11030470 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11030470 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

left_fish
false
0
Polygon -1 true false 256 131 279 87 285 86 300 120 285 150 300 180 287 214 280 212 255 166
Polygon -1 true false 165 195 181 235 205 218 224 210 254 204 240 165
Polygon -1 true false 225 45 217 77 229 103 214 114 134 78 165 60
Polygon -7566196 true true 270 136 149 77 74 81 20 119 8 146 8 160 13 170 30 195 105 210 149 212 270 166
Circle -16777216 true false 55 106 30

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6525626 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11030470 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11030470 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11030470 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11030470 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11030470 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.0pre3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
