globals [
  t agent-id rnd crnd orders costs n ordervalues inventory inbox
  relationship trade-q msg-clr del-clr requests request-trace delivery-trace
  num-of-ticks num-agents num-colo num-tele shape-list colors
]



to setup

  locals [
  i j colo-x tele-x angle-step current-x temp ii jj
  ]
  ca
  set num-of-ticks 200
  set num-agents 10
  set num-colo 5
  set num-tele num-agents - num-colo
  crt (num-agents * 2) ; create the players
  set i 0
  set j 0
  set shape-list (list "circle" "diamond" "triangle" "square" "x")
  set colors (list magenta white red blue brown yellow gray green orange pink)
  set colo-x 180 / (num-colo - 1)
  set tele-x 180 / (num-tele - 1)
  while [i < num-colo][
  ifelse 270 + i * colo-x < 360 [
  set current-x 270 + i * colo-x
  ]
  [
  set current-x 270 + i * colo-x - 360
  ]
  ask turtle i
   [

     set color black
     set heading 0
     fd 5
     set heading 90
     fd screen-edge-x / 2
     set temp i
     set ii 1
     while [temp >= 5][
       set temp temp - 5 * ii
       set ii ii + 1
     ]
     set shape item temp shape-list
     set heading current-x
     fd screen-edge-y - 10
     set pcolor-of (patch-here) item temp colors
     ask neighbors [set pcolor item temp colors]
   ]
   ask turtle (i + num-agents)
   [

     set color black
     set heading 0
     fd 5
     set heading 270
     fd screen-edge-x / 2
     set shape item temp shape-list
     set heading current-x
     fd screen-edge-y - 10
     set pcolor-of (patch-here) item temp colors
     ask neighbors [set pcolor item temp colors]
   ]
     set i i + 1
  ]

  while [j < num-tele][
    set current-x 90 + j * tele-x

    ask turtle (j + num-colo)
   [

     set color black
     set heading 180
     fd 5
     set heading 90
     fd screen-edge-x / 2
     set temp j
     set jj 1
     while [temp >= 5][
       set temp temp - 5 * jj
       set jj jj + 1
     ]
     set shape item temp shape-list;;;;there is a bug about getting -5 for turtle 18 here, fix it!
     set heading current-x
     fd screen-edge-y - 10
     set pcolor-of (patch-here) item (temp + 5) colors
     ask neighbors [set pcolor item (temp + 5) colors]
   ]
   ask turtle (j + num-colo + num-agents)
   [

     set color black
     set heading 180
     fd 5
     set heading 270
     fd screen-edge-x / 2
     set shape item temp shape-list
     set heading current-x
     fd screen-edge-y - 10
     set pcolor-of (patch-here) item (temp + 5) colors
     ask neighbors [set pcolor item (temp + 5) colors]
   ]
     set j j + 1
  ]


;  ask patches [
;    if (pycor = 0 or pycor = screen-edge-y) [
;    set pcolor red
;    ]
;    if ((pycor >= 0 and pycor <= screen-edge-y) and (pxcor = screen-edge-x or pxcor = 0 - screen-edge-x))[
;    set pcolor red
;    ]
;  ]
;  ca
;  crt 10 ; create the 10 players and sit them in a circle
;  set request-trace true
;  set delivery-trace true
;  ask turtles
;    [fd 15
;     set color black
;     set heading 0
;    ]
;  ask turtle 0[; player 0 is purple circle
;  set shape "circle"
;  set pcolor-of (patch-here) magenta
;  ask neighbors [set pcolor magenta]]
;  ask turtle 1; player 1 is yellow circle
;  [
;  set shape "circle"
;  set pcolor-of (patch-here) yellow
;  ask neighbors [set pcolor yellow]]
;  ask turtle 2; player 2 is black diamond
;  [
;   set shape "diamond"
;   set pcolor-of (patch-here) gray
;   ask neighbors [set pcolor gray]]
;  ask turtle 3 [; player 3 is white diamond
;  set shape "diamond"
;  set pcolor-of (patch-here) white
;  ask neighbors [set pcolor white]]
;  ask turtle 4 [;player 4 is blue square
;  set shape "square"
;  set pcolor-of (patch-here) blue
;  ask neighbors [set pcolor blue]]
;  ask turtle 5 [; player 5 is orange square
;  set shape "square"
;  set pcolor-of (patch-here) orange
;  ask neighbors [set pcolor orange]]
;  ask turtle 6 [ ;player 6 is green triangle
;  set shape "triangle"
;  set pcolor-of (patch-here) green
;  ask neighbors [set pcolor green]]
;  ask turtle 7 [; player 7 is red triangle
;  set shape "triangle"
;  set pcolor-of (patch-here) red
;  ask neighbors [set pcolor red]]
;  ask turtle 8 [; player 8 is brown x
;  set shape "x"
;  set pcolor-of (patch-here) brown
;  ask neighbors [set pcolor brown]]
;  ask turtle 9 [; player 9 is pink x
;  set shape "x"
;  set pcolor-of (patch-here) pink
;  ask neighbors [set pcolor pink]]

  set msg-clr green + 5; define the initial color of the request trace. It's light green.

  set del-clr blue + 5; define the initial color of the message trace.  It's light blue.

  set relationship [[0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]]
  ; relationship is their rating of one another. It is constructed as
  ; [[player 0's rating of player 0, player 0's rating of player 1,....player 0's rating of player9]
  ;  [player 1's rating of player 0, player 1's rating of player 1,....player 1's rating of player 9]
  ;           .
  ;           .
  ;  [player 9's rating of player 0, player 9's rating of player 1,....player 9's rating of player 9]]

  set trade-q [[0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]]
  ; trade-q is how many shapes each agent sells to other agents.  It is constructed as
  ; [[# of shapes player 0 sold to player 0, # of shapes player 0 sold to player 1,....# of shapes player 0 sold to player9]
  ;  [# of shapes player 1 sold to player 0, # of shapes player 1 sold to player 1,....# of shapes player 1 sold to player9]
  ;           .
  ;           .
  ;  [# of shapes player 9 sold to player 0, # of shapes player 9 sold to player 1,....# of shapes player 9 sold to player9]]

  set requests [[0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]
                    [0 0 0 0 0 0 0 0 0 0]  [0 0 0 0 0 0 0 0 0 0]]
  ; requests is how many requests are sent from a buyer to a seller.  It is constructed in the same way as trade-q

  set request-trace true; by default, the model shows the request trace.

  set delivery-trace true; by default, the model shows the delivery trace.
  set inbox [[] [] [] [] [] [] [] [] [] []]; initiate the empty inbox for their requests
  setup-plots

end

to setup-plots

  set-current-plot "seller's rating of the buyer"
  set-plot-y-range 0 1
  set-current-plot "# of shapes sold"
  set-plot-y-range 0 10
  ;set-current-plot "buyer's rating of the seller"
  ;set-plot-y-range 0 1
  ;set-current-plot "# of requests sent"
  ;set-plot-y-range 0 20

end

to go
  while [t < num-of-ticks];In the actual Shape Factory experiment, the 10 human subjects usually can take a total of 200 actions in a round.
  [
  set rnd int(t / num-of-ticks) + 1
  if (rnd > crnd) [initiate-round]
  set crnd  rnd
  turtle-trading t
  set t t + 1
  do-plots
  show t
  ]
end

to turtle-trading [time]
  set agent-id random 10;in every time step, randomly pick an agent and let him buy or sell, or do both.

  turtle-buy agent-id time

  turtle-sell agent-id time

end

to turtle-buy [id time]

  locals [i own-inventory own-orders]

  set own-inventory item id inventory
  set own-orders item id orders

  set i 0
    while [i < 8][
      if ((item i own-inventory) = 0)[; the agent look through his inventory and
                                      ;find out which shape is in need and send out a request for the shape
      send-request id i time
      stop; once a request is sent out, the turtle-buy procedure stops
      ]
    set i i + 1
    ]


end

to turtle-sell [id time]

  locals [temp i number-of-msg shape-in-request own-orders
  shape-price own-cost own-relationship best-relation msg-id
  buyer-id buyer-inventory inventory-position m h]

  set temp item id inbox; retrieve all the requests sent to this agent from the inbox
  if (empty? temp) [stop]; if no one sent a request to this agent, stop the procedure
  foreach (temp)[; interate through all the requests sent to this agent
                 ; each request is coded as sender id + receiver id + requested shape id + price + time sent out + responded/not

  set buyer-id first ?; retrieve the sender id, it's the first digit of the request string
  set buyer-id read-from-string buyer-id

  set buyer-inventory item buyer-id inventory
  set inventory-position item 2 ?; retrieve the shape in request, it's the third item of the request string
  set inventory-position read-from-string inventory-position
  if (last ? = 0 or item inventory-position buyer-inventory = 1)[; if this agent has responded to the request in previous time steps,
                                                                 ; or if the sender has bought the shape from other agent, exclude the
                                                                 ; request from the potential deals
  set temp remove ? temp
  ]
  ]

  set number-of-msg length temp

  set own-cost item id costs

  if (number-of-msg = 0)[; if there is no potential deals, stop the procedure
    stop
  ]

  if (number-of-msg = 1)[; if there is one request, decide whether to accept
     set h read-from-string first first temp; retrieve the sender id
     set own-orders item (h) orders; retrieve the sender's orders
     set h read-from-string item 2 (item 0 temp); retrieve the requested shape
     set shape-in-request item h own-orders; find out the id of the requested shape
     set h read-from-string item 3 (item 0 temp); the first digit of the price
     set m read-from-string item 4 (item 0 temp); the second digit of the price
     set shape-price (h * 10 + m); transform the price from string to numeric value

     if (shape-price > min own-cost and (id * 2 = shape-in-request or id * 2 + 1 = shape-in-request))[; if the offered buying price
                                                                                                      ; is greater than his own cost
                                                                                                      ; accept the deal
     set best-relation item 0 temp
     accept-deal best-relation time 0
     stop
     ]


  stop
  ]

  if (number-of-msg > 1)[; if there are more than 1 potential deals
      set own-relationship item id relationship
      set best-relation item 0 temp
      foreach temp[
      set m read-from-string first ?
      set h read-from-string first best-relation
      if (item (m) own-relationship > item (h) own-relationship )[
      set best-relation ?; find out this agent's best rated potential buyer, and sell to him/her
      set msg-id position ? temp]
      ]
    accept-deal best-relation time msg-id
  ]

end

to send-request [agent-from inventory-in-need time]

  locals [own-orders own-cost own-inventory agent-to own-relationship
  this-price this-request own-message shape-in-need own-requests m]

  set own-orders item agent-from orders
  set own-cost item agent-from costs
  set own-inventory item agent-from inventory
  set own-relationship item agent-from relationship
  set shape-in-need item inventory-in-need own-orders
  set own-requests item agent-from requests

  ifelse ((item (shape-in-need * 2) own-relationship) >= (item (shape-in-need * 2 + 1) own-relationship)) [
    set agent-to shape-in-need * 2]
    [set agent-to shape-in-need * 2 + 1]; compare the ratings of the two experts of the shape, and send a request
                                        ; to the better rated one.

  set this-price int((mean list min own-cost max own-cost)); the offered buying price is the mean of the sender's
                                                           ; low and high costs
  ; capture requests sent here this-price agent-from inventory-in-need time

  set this-request (word agent-from agent-to inventory-in-need this-price time 0); concatenate sender id, receiver id
                                                                                 ; shape requested, price, time sent
                                                                                 ; and responde/not to the request string
  set m item agent-to own-requests
  set m m + 1
  set own-requests replace-item agent-to own-requests m
  set requests replace-item agent-from requests own-requests
  ; update the number of requests from the buyer to the seller

  set own-message item agent-to inbox


  set own-message lput this-request own-message

  set inbox replace-item agent-to inbox own-message; put the new request to the receiver's inbox

  if (request-trace)[
  set msg-clr msg-clr - 0.03; each new request will make the color of the request trace darker
  draw-trace agent-from agent-to msg-clr
  ]


end

to accept-deal [deal time msg-id]

  locals[buyer seller own-inventory shape-delivered own-orders inventory-filled
  own-msg m quantity own-quantity]
  set buyer read-from-string item 0 deal
  set seller read-from-string item 1 deal
  set own-inventory item buyer inventory
  set own-orders item buyer orders

  set own-quantity item seller trade-q
  set quantity item buyer own-quantity;update trading quantities between the two
  set quantity quantity + 1
  set own-quantity replace-item buyer own-quantity quantity
  set trade-q replace-item seller trade-q own-quantity

  set inventory-filled item 2 deal
  set m read-from-string inventory-filled
  set shape-delivered item m own-orders
  set own-msg item seller inbox

  set own-inventory replace-item m own-inventory 1;update buyer's inventory

  set inventory replace-item buyer inventory own-inventory

  set m (length deal - 1)
  set deal replace-item m deal "1"
  ;change the request to a responded one
  set own-msg replace-item msg-id own-msg deal

  set inbox replace-item seller inbox own-msg


  update-relationship deal time

  if (delivery-trace)[
  set del-clr del-clr - 0.05; each new delivery will make the delivery trace darker
  draw-trace (seller + num-agents) (buyer + num-agents) del-clr
]
end

to update-relationship [info time]

  locals[buyer seller this-shape own-cost-buyer own-cost-seller price time-sent
  own-relation-buyer own-relation-seller respond-time current-rate low-cost-buyer
  high-cost-seller m h own-orders]

  set buyer read-from-string item 0 info
  set seller read-from-string item 1 info

  set m read-from-string item 3 info
  set h read-from-string item 4 info
  set price m * 10 + h
  set time-sent read-from-string item 5 info

  set own-orders item buyer orders
  set this-shape read-from-string item 2 info
  set m item this-shape own-orders

  set own-cost-buyer item m (item buyer costs)
  set low-cost-buyer min (item buyer costs)
  set own-relation-buyer item buyer relationship

  set own-cost-seller item m (item seller costs)
  set high-cost-seller max (item seller costs)
  set own-relation-seller item seller relationship

  set respond-time (time - time-sent)
  set current-rate item seller own-relation-buyer;first, update buyer's rating of the seller
  set current-rate (current-rate + ((200 - respond-time) / 200) + ((own-cost-buyer - price)/(own-cost-buyer - low-cost-buyer))) / 2
  set own-relation-buyer replace-item seller own-relation-buyer current-rate
  set relationship replace-item buyer relationship own-relation-buyer
  ;buyer's rating of the seller is depending on the seller's responsiveness and the selling price

  set current-rate item buyer own-relation-seller;second, update seller's rating of the buyer
  set current-rate (current-rate + ((price - own-cost-seller)/(high-cost-seller - own-cost-seller))) / 2
  set own-relation-seller replace-item buyer own-relation-seller current-rate
  set relationship replace-item seller relationship own-relation-seller
  ; seller's rating of the buyer is depending on the price premium he gets from the buyer


end

to draw-trace [startp endp clr]
  locals [h]

  if (startp = endp)[stop]

  ask turtle startp
    [hatch 1
    [set color clr


     set heading towards-nowrap turtle endp
     fd 3
     pen-down
     set color clr
     set heading towards-nowrap turtle endp
     fd distance-nowrap turtle endp - 3]
    ]



end


to initiate-round
locals [temp i]
  set orders [[4 1 4 1 2 3 1 4] [4 1 4 1 2 3 1 4]
              [2 3 2 3 4 0 3 2] [2 3 2 3 4 0 3 2]
              [3 0 3 0 4 1 0 3] [3 0 3 0 4 1 0 3]
              [4 0 4 0 2 1 0 4] [4 0 4 0 2 1 0 4]
              [1 2 1 2 3 0 2 1] [1 2 1 2 3 0 2 1]]

  ;orders set for purple circle, yellow circle, black diamond, white diamond,
  ;blue square, orange square, red triangle, green triangle, pink x, brown x
  ;0--circle, 1--diamond, 2--square, 3--triangle, 4--x



  set costs (list (list (15 + random 5) (25 + random 5) (25 + random 5) (25 + random 5) (25 + random 5))
                  (list (15 + random 5) (25 + random 5) (25 + random 5) (25 + random 5) (25 + random 5))
                  (list (25 + random 5) (15 + random 5) (25 + random 5) (25 + random 5) (25 + random 5))
                  (list (25 + random 5) (15 + random 5) (25 + random 5) (25 + random 5) (25 + random 5))
                  (list (25 + random 5) (25 + random 5) (15 + random 5) (25 + random 5) (25 + random 5))
                  (list (25 + random 5) (25 + random 5) (15 + random 5) (25 + random 5) (25 + random 5))
                  (list (25 + random 5) (25 + random 5) (25 + random 5) (15 + random 5) (25 + random 5))
                  (list (25 + random 5) (25 + random 5) (25 + random 5) (15 + random 5) (25 + random 5))
                  (list (25 + random 5) (25 + random 5) (25 + random 5) (25 + random 5) (15 + random 5))
                  (list (25 + random 5) (25 + random 5) (25 + random 5) (25 + random 5) (15 + random 5)))
  ;costs set for purple circle, yellow circle, black diamond, white diamond,
  ;blue square, orange square, red triangle, green triangle, pink x, brown x

  set ordervalues []; order values don't have any use to the current model.
  set i 0
  while [i < 10][
  set temp item i orders
  foreach temp[
  set ordervalues lput (item ? (item i costs)) ordervalues
  ]
  set i i + 1
  ]

  set inventory [[0 0 0 0 0 0 0 0][0 0 0 0 0 0 0 0][0 0 0 0 0 0 0 0]
                   [0 0 0 0 0 0 0 0][0 0 0 0 0 0 0 0][0 0 0 0 0 0 0 0]
                   [0 0 0 0 0 0 0 0][0 0 0 0 0 0 0 0][0 0 0 0 0 0 0 0]
                   [0 0 0 0 0 0 0 0]]
  ; in the beginning of a new round, all the inventory from previous round is washed away

end

to do-plots

  locals[seller buyer relation1 relation2 quantity own-requests]
  set seller read-from-string last which-seller
  set buyer read-from-string last which-buyer
  set relation1 item buyer (item seller relationship)
  set relation2 item seller (item buyer relationship)
  set quantity item buyer (item seller trade-q)
  set own-requests item seller (item buyer requests)
  set-current-plot "seller's rating of the buyer"
  plot relation1
  ;set-current-plot "buyer's rating of the seller"
  ;plot relation2
  set-current-plot "# of shapes sold"
  plot quantity
  ;set-current-plot "# of requests sent"
  ;plot own-requests

end
@#$#@#$#@
GRAPHICS-WINDOW
184
10
999
446
80
40
5.0
1
10
1
1
1
0

CC-WINDOW
5
607
1008
702
Command Center

BUTTON
25
74
84
107
NIL
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
96
74
159
107
NIL
go
T
1
T
OBSERVER
T
NIL

PLOT
11
157
179
287
seller's rating of the buyer
time
rating
0.0
100.0
0.0
100.0
true
false

PLOT
12
298
175
436
# of shapes sold
time
quantity
0.0
100.0
0.0
100.0
true
false

CHOOSER
29
501
167
546
which-seller
which-seller
"purple0" "yellow1" "black2" "white3" "blue4" "orange5" "green6" "red7" "brown8" "pink9"
3

CHOOSER
29
456
167
501
which-buyer
which-buyer
"purple0" "yellow1" "black2" "white3" "blue4" "orange5" "green6" "red7" "brown8" "pink9"
2

TEXTBOX
213
458
320
593
Note:\nrequest-trace is in the color of green, and delivery-trace is in blue.\nThe more requests or deliveries, the darker the color of the trace.

@#$#@#$#@
Nathan Bos
Erik Johnston
Ning Nan
NetLogo Workshop 2004



Model developed by Ning Nan, University of Michigan School of Business Administration
contact: nnan@umich.edu

Shape Factory was developed by researchers at theCollaboratory for Research on Electronic Work, University of Michigan  crew.umich.edu

Note: due to continuous updates to the model, there is some inconsistency between
the model and the description below.  I apologize for any confusion this might cause.

WHAT IS IT?
-----------
This is the computer simulation of a lab experiment, Shape Factory. Shape Factory is a game for stuying the collaboration patterns among distributed teams.  This model uses a particular configuration, when all the team members are remote.  We hope to see the formation of social exchange networks among the agents.


HOW IT WORKS
------------
Agents always send requests and sell shapes to those agents who have the best relationship with them.  Their relationship is determined by their responsiveness to each other and the price premium they get from previous transactions.


HOW TO USE IT
-------------
In the interface, you can decide whether to view the traces of their requests and deliveries. By default, they are on.  These traces visualize the formation of their social exchange networks. The darker the color of the traces, the more requests or shapes are sent between two agents.  In this sense, the darker traces mean better relationships.  So by looking at the trace map, we can  tell which pairs of agents develop better relationship throughout the play, and which pairs of agents do not get along very well.

Note: request trace is in green and delivery trace is in blue.

There are also two plots in the interface.  The top one shows a seller's rating of a buyer.  The bottom one shows the number of shapes sold from the seller to the buyer. You can choose which seller and buyer you want to observe from the drop down menues below the plots.

The command center shows the log of their requests and relationship throughout the game.  They are updated after each time period.

THINGS TO NOTICE
----------------
By looking at the two plots, you can see whether the rating of a seller to a buyer changes in the similar pattern with the number of shapes sold from the seller to the buyer. Our hypothesis is that they are positively correlated.

Also, in the end of the play, find out which pairs of agents developed better relationships (darker traces), and compare it to the log in the command center. Agents have better relationship with others should get more requests and higher relationship values.


THINGS TO TRY
-------------
For those who are interested, you can extract more data from the play by asking the command center to show the log of other variables.  Later, export the log to a spreadsheet and do varies statistical tests.


EXTENDING THE MODEL
-------------------
You can try to change the algorithm of their relationship values.  For example, remove responsiveness and make only price history matter.


@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7566196 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7566196 true true 150 285 285 225 285 75 150 135
Polygon -7566196 true true 150 135 15 75 150 15 285 75
Polygon -7566196 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7566196 true true 96 182 108
Circle -7566196 true true 110 127 80
Circle -7566196 true true 110 75 80
Line -7566196 true 150 100 80 30
Line -7566196 true 150 100 220 30

butterfly
true
0
Polygon -7566196 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7566196 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7566196 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7566196 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7566196 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7566196 true true 47 195 58
Circle -7566196 true true 195 195 58

circle
false
0
Circle -7566196 true true 0 0 300

circle 2
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7566196 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7566196 true true 73 210 86 251 62 249 48 208
Polygon -7566196 true true 25 114 16 195 9 204 23 213 25 200 39 123

diamond
false
0
Polygon -7566196 true true 150 15 45 150 150 285 255 150

face happy
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7566196 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7566196 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7566196 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7566196 true true 60 15 75 300
Polygon -7566196 true true 90 150 270 90 90 30
Line -7566196 true 75 135 90 135
Line -7566196 true 75 45 90 45

flower
false
0
Polygon -11352576 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7566196 true true 85 132 38
Circle -7566196 true true 130 147 38
Circle -7566196 true true 192 85 38
Circle -7566196 true true 85 40 38
Circle -7566196 true true 177 40 38
Circle -7566196 true true 177 132 38
Circle -7566196 true true 70 85 38
Circle -7566196 true true 130 25 38
Circle -7566196 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -11352576 true false 189 233 219 188 249 173 279 188 234 218
Polygon -11352576 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7566196 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7566196 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7566196 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7566196 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7566196 true 150 0 150 300

pentagon
false
0
Polygon -7566196 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7566196 true true 110 5 80
Polygon -7566196 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7566196 true true 127 79 172 94
Polygon -7566196 true true 195 90 240 150 225 180 165 105
Polygon -7566196 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7566196 true true 135 90 165 300
Polygon -7566196 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7566196 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7566196 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7566196 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7566196 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7566196 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7566196 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7566196 true true 30 30 270 270

square 2
false
0
Rectangle -7566196 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7566196 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7566196 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7566196 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7566196 true true 120 120 60

tree
false
0
Circle -7566196 true true 118 3 94
Rectangle -6524078 true false 120 195 180 300
Circle -7566196 true true 65 21 108
Circle -7566196 true true 116 41 127
Circle -7566196 true true 45 90 120
Circle -7566196 true true 104 74 152

triangle
false
0
Polygon -7566196 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7566196 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7566196 true true 4 45 195 187
Polygon -7566196 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7566196 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7566196 false true 24 174 42
Circle -7566196 false true 144 174 42
Circle -7566196 false true 234 174 42

turtle
true
0
Polygon -11352576 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -11352576 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -11352576 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -11352576 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -11352576 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7566196 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7566196 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7566196 true 150 285 150 15
Line -7566196 true 15 150 285 150
Circle -7566196 true true 120 120 60
Line -7566196 true 216 40 79 269
Line -7566196 true 40 84 269 221
Line -7566196 true 40 216 269 79
Line -7566196 true 84 40 221 269

x
false
0
Polygon -7566196 true true 270 75 225 30 30 225 75 270
Polygon -7566196 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 2.1beta4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
