	breeds [villes voyageurs elites]

globals[
          listeville ;;la liste des id des villes
          listevoyageurs ;; idem pour les voyageurs
          tau0 ;;valeur par defaut de tau
          Tplus ;;meilleure liste de ville
          Lplus ;;meilleure distance
          elite
          alpha
          beta
          rho
          nbfour
          nbville
          Q
          cycle
          init?

          pheromin  ;; pour faire un degrad de couleur
          pheromax
          coeff  ;; coeff de mise a l'echelle des couleurs
          offset
]



turtles-own[



]

villes-own[
            distauvoisin   ;;liste des distances
            invdistauvoisin;;inverse de la distance = desirabilit
            pheroauvoisin  ;;liste des quantits de phero par lien
            voisins        ;;les voisins
            coordx
            coordy        ;;les coord de la villes

]

voyageurs-own[
              Tvisite       ;;listes des villes visites
              ville        ;;la ville actuelle
              villeinit   ;;la ville de depart
              Lmoi
             ]

elites-own[
            Tvisite
            villeinit
            ville
         ]

patches-own[

]




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;INITIALISATIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to startup   ;;1ere proc lancer par netlogo

set init? false
set listeville []
set listevoyageurs []
set tau0 0.000001
set Tplus []
set Lplus 999999999
set elite 5

set importance-aleatoire 5
set alpha 6 - importance-aleatoire
set beta importance-aleatoire

set evaporation ( 0.5 * 100 )
set rho ( evaporation / 100 )
set nombre-villes 20
set nbville nombre-villes
set nbfour  nbville
set Q 100
set cycle 0


initialiser

end



to initialiser



set init? false

wait 1.0


ca


set tau0 0.000001
set Tplus []
set Lplus 999999999
set elite 5
set alpha 6 - importance-aleatoire
set beta importance-aleatoire
set rho ( evaporation / 100 )
set nbville nombre-villes
set nbfour nbville
set Q 100
set cycle 0

generermap


set listevoyageurs []
create-custom-voyageurs nbfour [
  hideturtle

  set Tvisite []
  set villeinit turtle (random-one-of listeville)
  set Tvisite lput (who-of villeinit) Tvisite

  set Lmoi 0
  set ville villeinit
    set xcor xcor-of villeinit
    set ycor ycor-of villeinit

]
create-custom-elites 1 [
  hideturtle
  set ville one-of villes
  set villeinit ville
]

set listevoyageurs values-from voyageurs [who]
set listevoyageurs sort listevoyageurs

wait 0.1
set init? true

end






to generermap



set listeville []
ct
set-default-shape villes "circle"

create-custom-villes nbville [
set size 6.0
set label who
set label-color (yellow + 2)
set color (green - 2)
setxy random-float ( screen-size-x )
      random-float ( screen-size-y )
if (xcor < 10 - screen-edge-x )[set xcor 10 - screen-edge-x]
if (ycor < 10 - screen-edge-y )[set ycor 10 - screen-edge-y]
if (xcor > screen-edge-x - 10)[set xcor screen-edge-x - 10]
if (ycor > screen-edge-y - 10)[set ycor screen-edge-y - 10]

      ]
set listeville values-from villes [who]
set listeville sort listeville

ask villes[
set voisins []
set invdistauvoisin []
set distauvoisin []
     ;;initialise la variable comme une liste
calculer-distance

set pheroauvoisin []

init-phero

]


end





to calculer-distance
foreach listeville
[
 ifelse (? != who)
 [
 set distauvoisin lput (distance-nowrap turtle ?) distauvoisin
 set invdistauvoisin lput (1 / (distance-nowrap turtle ?)) invdistauvoisin
 set voisins lput ? voisins
]
[
  set distauvoisin lput (0) distauvoisin
  set invdistauvoisin lput (999999999) invdistauvoisin
]
]
end


to init-phero

foreach listeville
[
set pheroauvoisin lput tau0 pheroauvoisin
]

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;LANCER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;boucle principale;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to lancer

if (is-boolean? init?)
[

  ifelse (init?)
  [
    set cycle (cycle + 1)

    ;;on met  jour les valeurs alpha beta
    set alpha 6 - importance-aleatoire
    set beta importance-aleatoire

    ask voyageurs[
      realiser-tour
      calculer-longueur
    ]
  chercher-meilleurnouveautour
  maj-phero

  afficherpiste
  ]
  [
  wait 1.0
  ]
]

end

;;;;;;;;;;;;;;;;;les fonctions;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to realiser-tour      ;;propre a voyageurs
locals [listproba prob val listville index listphero listinvdist i]
set listproba []
set listville []
set listphero []
set listinvdist []

set Tvisite [] ;; on reinit la liste
set Tvisite lput (who-of villeinit) Tvisite
set ville villeinit

set listville listeville  ;; on recupere les villes


while [(length Tvisite) < nbville][

set listproba []
set listphero (pheroauvoisin-of ville)
set listinvdist (invdistauvoisin-of ville)


  foreach listville  ;;pour ce qui reste a visiter, on calcul la proba d'y aller...
  [
    ifelse ( not (member? ? Tvisite))
    [

     set index position ? listville
     set prob ( ( (item index listphero  ) ^ alpha) * ( (item index listinvdist ) ^ beta ) )

     set listproba lput (prob) listproba

    ]
    [
    set listproba lput (0) listproba
    ]

  ]

 set index 1
  while [index < length listproba]    ;; on definit une liste croissante de proba par ville
  [
    set listproba replace-item index listproba (item index listproba + item (index - 1) listproba)
    set index (index + 1)
  ]


  ;; on tire un nombre au pif entre 0 et la val max des proba, on en deduit une ville
  set val random-float (last listproba)


  ;; val se place forcement dans un interval de valeur 0-p1 ou p1-p2 ou ... p(n-1) pn
  set index 0
  set prob item index listproba

  while [(val > prob) and (index < length listproba) ]
  [
    set index (index + 1)
    set prob item index listproba
  ]
  ;; on a la bonne valeur par rapport a la proba


  set prob item index listproba
  set index position prob listproba ;;renvoie le 1er element de cette valeur!!!


  set Tvisite lput (item index listville) Tvisite
  set ville turtle (last Tvisite)

]


end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to calculer-longueur
locals [i long villesuivante]
set i 0
set long 0
set ville turtle (item i Tvisite)
set villesuivante (item (i + 1) Tvisite)

while [i < length Tvisite - 1]
[

  set ville turtle (item i Tvisite)
  set villesuivante (item (i + 1) Tvisite)
  set long (long + item villesuivante (distauvoisin-of ville))
  set i (i + 1)

]

set ville turtle (last Tvisite)
set villesuivante (first Tvisite)

set long (long + item villesuivante (distauvoisin-of ville))

set Lmoi long

end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to chercher-meilleurnouveautour
locals [best cur voya i numcur]


set voya[]
set cur[]
set numcur[]
set voya listevoyageurs

foreach listevoyageurs
[
 set cur lput (Lmoi-of (turtle ?) ) cur
 set numcur lput ? numcur
]


set best min cur

if (best < Lplus)
  [
  set Lplus best
  set i position best cur  ;; on recupere l'indice dans la liste du meilleur element

  set i item i listevoyageurs ;;on retrouve le voyageur

  set Tplus Tvisite-of (turtle i)  ;;et son chemin

  ]


end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to maj-phero

;; 3phases ici
;; 1. evaporer de (1-rho) l'ancienne trace
;; 2. renforcer les pistes emprunte sur ce tour
;; 3. Ajouter des elites qui vont renforcer le meilleurs chemin
ask villes[
evaporer
]
ask voyageurs[
ajouterfrequenter
]
ajouterelite

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to evaporer ;; on reduit les listes de phero par evapo
locals [new]

set new []

foreach pheroauvoisin
[
set new lput ((1 - rho) * ? ) new
]
set pheroauvoisin new


end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to ajouterfrequenter

locals [phero i cur next]

set i 0
set phero (Q / Lmoi)

foreach Tvisite
[
set cur ?
if (last Tvisite != ?)
[set next item (1 + (position ? Tvisite)) Tvisite
ask turtle ? [
 set pheroauvoisin replace-item next pheroauvoisin ( (item next pheroauvoisin) + phero )
] ;;ask

] ;;if
] ;;foraech

set next item 0 Tvisite
ask turtle (last Tvisite)[
  set pheroauvoisin replace-item next pheroauvoisin ( (item next pheroauvoisin) + phero )
]


end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to ajouterelite

locals [phero i cur next]

set i 0
set phero (Q / Lplus)

foreach Tplus
[
set cur ?
if (last Tplus != ?)
[set next item (1 + (position ? Tplus)) Tplus
ask turtle ? [
 set pheroauvoisin replace-item next pheroauvoisin ( (item next pheroauvoisin) + e * phero )

] ;;ask
] ;;if
] ;;foraech

set next item 0 Tplus
ask turtle (last Tplus)[
  set pheroauvoisin replace-item next pheroauvoisin ( (item next pheroauvoisin) + e * phero )
]

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;AFFICHAGE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to afficherpiste

no-display
clear-patches

preparerdegrader

if (afficher = "meilleur chemin" or afficher = "les deux")
[
ask elites     ;;on trace dabord elite afin que la trace ideale soit sous les trace dephero
[
set Tvisite Tplus
set ville turtle first Tvisite
set xcor (xcor-of ville + 1)
set ycor (ycor-of ville + 1)
tracerelite
]
]
if (afficher = "pheromones" or afficher = "les deux")
[
ask voyageurs[
tracer
]
]


display
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to tracer
locals [cur next]

pendown
without-interruption[
foreach Tvisite
[
set cur ?
if (last Tvisite != ?)
[
set ville turtle cur
set next item (1 + (position ? Tvisite)) Tvisite

choixcouleur( item next (pheroauvoisin-of ville) )
set heading towards-nowrap turtle next
fd distance-nowrap turtle next

] ;;if
] ;;foraech

set ville turtle (last Tvisite)
set next first Tvisite

choixcouleur( item next (pheroauvoisin-of ville) )
set heading towards-nowrap turtle next
fd distance-nowrap turtle next
]

penup

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to tracerelite
locals [cur next]

pendown
without-interruption[
foreach Tvisite
[
set cur ?
if (last Tvisite != ?)
[
set ville turtle cur
set next item (1 + (position ? Tvisite)) Tvisite

set color red
set xcor (xcor-of ville + 1) set ycor (ycor-of ville + 1)
set heading towardsxy-nowrap ((xcor-of turtle next) + 1) ((ycor-of turtle next) + 1)
fd distance-nowrap turtle next

] ;;if
] ;;foraech

set ville turtle (last Tvisite)
set next first Tvisite

set color red
set xcor (xcor-of ville + 1) set ycor (ycor-of ville + 1)
set heading towardsxy-nowrap ((xcor-of turtle next) + 1) ((ycor-of turtle next) + 1)
fd distance-nowrap turtle next
]

penup

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to preparerdegrader
locals [listemin listemax]
set listemin []
set listemax []

ask villes[
set listemin lput (min pheroauvoisin) listemin
set listemax lput (max pheroauvoisin) listemax
]
set pheromin min listemin
set pheromax max listemax
set coeff ( ( 4 - (-4) ) / ( pheromax - pheromin) )
set offset ( -4 - (coeff * pheromin))
end

to choixcouleur [ phero ]

;; on degrade en vert
;; pheromin vaut green - 4 et max vaut green + 4
set color (green + ( coeff * phero + offset ))

end



@#$#@#$#@
GRAPHICS-WINDOW
307
10
795
659
119
154
2.0
1
10
1
1
1
0

CC-WINDOW
5
673
804
768
Command Center

BUTTON
148
81
304
121
validation
initialiser
NIL
1
T
OBSERVER
T
NIL

BUTTON
3
10
94
75
action/pause
lancer
T
1
T
OBSERVER
T
NIL

MONITOR
152
10
304
59
meilleure distance trouvee
Lplus
3
1

MONITOR
98
10
148
59
cycles
cycle
3
1

SLIDER
3
81
143
114
nombre-villes
nombre-villes
10
30
20
1
1
NIL

SLIDER
148
131
304
164
importance-aleatoire
importance-aleatoire
0
6
5
1
1
NIL

TEXTBOX
7
198
303
655
Mode d'emploi :\n\n1. Cliquez sur action/pause. En rouge apparait la piste du plus court chemin trouve entre les villes (petits cercles numerotes).\n2. Vous pouvez interrompre / reprendre la simulation en cliquant sur action/pause.\n3. Vous pouvez initialiser une nouvelle simulation avec un autre nombre de villes en bougeant le curseur nombre-villes et en cliquant ensuite sur validation.\n\n4. En choisissant "pheromones" dans la liste sous "afficher", les pistes de pheromones apparaissent en vert. Les pistes claires sont les plus concentrees en pheromones. Pour afficher a nouveau le meilleur chemin, choisissez "meilleur chemin" dans le menu afficher.\n\n5. Le curseur importance-aleatoire vous permet de modifier l'importance de la recherche aleatoire de chemin, par rapport a la recherche en suivant les traces de pheromones. A 0, seules les pheromones ont de l'importance, a 6, seul l'aleatoire a de l'importance. \n\n6. Le curseur evaporation permet de definir la quantite de pheromone qui va s'evaporer d'un cycle a l'autre.

CHOICE
3
141
143
186
afficher
afficher
"meilleur chemin" "pheromones" "les deux"
0

TEXTBOX
314
14
791
34
        Recherche du plus court chemin entre plusieurs villes.

SLIDER
148
169
304
202
evaporation
evaporation
0
100
50
1
1
%

@#$#@#$#@
DE QUOI S'AGIT IL ?
-------------------

Cette applet illustre la rsolution du problme du voyageur de commerce.

Un voyageur doit passer par un certain nombre de villes, toutes diffrentes, et revenir  sa ville de dpart. Il doit obligatoirement passer par chaque ville, et ne doit y aller qu'une seule fois durant son voyage.

Le but est de trouver le chemin le plus court reliant toutes les villes.

L'applet montre que l'emploi d'un systme de rsolution bas sur le comportement des fourmis et leur capacit  trouver le plus court chemin entre deux points permet de rsoudre un tel problme.

Le programme donne le meilleur ordre des villes  visiter trouv, ainsi que la longueur du trajet.

(Attention, selon la puissance de votre ordinateur, il faudra envisager d'tre patient!)


QUEL EST LE PRINCIPE ?
----------------------

Afin de trouver le parcours idal, un ensemble de fourmis (autant que de ville) va tre plac alatoirement sur les diffrentes villes. A partir de ce point de dpart, elles vont aller de ville en ville.

Les fourmis vont donc faire des tours ("cycles") pendant lesquels elles vont se promener sur un chemin ferm reliant toutes les villes. On parlera de piste pour dsigner le morceau de chemin qui relie deux villes.

A chaque passage sur une piste entre deux villes, les fourmis vont dposer des phromones; la quantit dpose sera leve si la piste est courte, et  l'inverse, faible, si la piste est longue.

De ce fait, pendant chaque cycle, les fourmis auront un choix  faire en arrivant dans une nouvelle ville : O aller ensuite?
Pour rpondre  cette question, les fourmis vont tre influences par deux critres :
* suivre une piste ayant des phromones
* s'orienter vers une autre ville alatoirement, en privilgiant les plus proches

Cel signifie que les fourmis vont avoir une certaine probabilit d'aller dans la ville suivante.
Cette probabilit sera plus leve :
* si la piste a beaucoup de phromones (donc frquente),
* ou si la ville est proche.
A l'inverse, elle sera plus faible :
* si la piste est peu frquente,
* ou si la ville est loin.

Cependant, suivre une piste frquente augmente les risques de suivre toujours les mmes pistes dans le mme ordre et donc de suivre toujours le mme chemin, en vitant des pistes aboutissant  des chemins potentiellement meilleurs. A l'oppos, suivre des pistes alatoirement donne moins de chance de tomber sur la suite de villes idale. C'est pourquoi les deux facteurs rentrent en compte, et permettent ensemble de trouver le plus court chemin.

Afin que les phromones ne s'accumulent pas d'un cycle  l'autre, et incitent les fourmis  toujours prendre le mme chemin, celles-ci vont s'vaporer en partie entre chaque cycles afin de permettre l'utilisation de nouvelles pistes.


COMMENT AGIR SUR LE PROGRAMME ?
-------------------------------

Pour lancer une simulation par dfaut, cliquez sur "lancer". 10 villes vont tre places alatoirement sur la carte.

Pour interrompre ou reprendre l'excution du programme, cliquez sur "lancer".

Vous pouvez choisir le nombre de villes  placer sur la carte  l'aide du curseur "nombre-villes" et en cliquant ensuite sur "nouvelle simulation".

Lors des simulations vous pouvez agir sur deux paramtres :
* "importance-aleatoire" qui dtermine l'importance du critre alatoire dans le choix de l'ordre des villes  visiter.
Quand cette valeur vaut 0, les fourmis ne suivent que les pistes ayant des phromones, et suivront donc prioritairement les pistes les plus visites.
Quand cette valeur vaut 6, les fourmis ne suivront pas du tout les pistes de phromones, et choisiront les villes alatoirement, en favorisant les villes les plus proche de leure ville courante.

* "evaporation" determine la quantit de phromones qui va s'vaporer  chaque cycle, donc  chaque tour complet des fourmis. Plus l'vaporation est leve, plus les pistes de phromones vont s'effacer, et donc plus elles seront difficiles  suivre et attireront peu les fourmis. Plus elle sera faible, plus les pistes dj frquentes seront marques et seront prises lors du choix de la ville suivante.

Concernant l'affichage, il est possible d'afficher le chemin correspondant au meilleur choix trouv, en choisissant "meilleur chemin" dans la liste "afficher". Il est aussi possible d'afficher les phromones en choisissant "pheromones"; les phromones apparatront alors en nuance de vert, plus cette nuance est claire, plus il y a de phromones sur ce passage.


POINTS A NOTER
--------------

Le monde des fourmis est ici entirement plat. Les individus ne peuvent sortir par un bord de l'cran pour rejoindre l'autre bord, contrairement  la simulation du cercle.

Les facteurs d'vaporation et de choix alatoire sont complmentaires. Bien que ceux-ci semblent avoir un effet similaire, il n'agissent pas sur les mmes critres. L'alatoire agit sur le choix de la ville suivante lorsqu'une fourmi cherche  faire un tour; tandis que l'vaporation agit sur l'importance qu'a un  chemin dj explore par rapport aux autres et donc incite les fourmis  chercher des pistes proches du chemin.

Il faut parfois tre patient. Selon le nombre de ville, et la complexit de leur rpartition, de nombreux cycles (de l'ordre de la centaine, parfois du millier) peuvent tre ncessaire pour trouver la meilleure route. Il est mme possible que le systme ne trouve pas la meilleure route en un temps "raisonnable" pour l'utilisateur, mais une configuration trs proche.

Des systmes bass sur le mme principe, mais plus avancs d'un point de vue technique donnent encore de meilleurs rsultats! Mais cel dpasse l'objectif d'illustration de ce programme.

A titre d'information, la mthode mise en place pour cette prsentation, base sur les travaux de Marco Dorigo, permet de trouver la meilleure solution pour un problme avec 30 villes diffrentes et avec un nombre de cycle infrieur  3000. (Ce nombre ne reprsente pas la vitesse du programme, car il dpend entirement de la machine qui fait les calculs et des conditions d'utilisation. Par exemple, la mme mthode sans aucun affichage serait dj beaucoup plus rapide.)


QUELQUES TRUCS A ESSAYER
------------------------

Essayer de favoriser le caractre alatoire de la recherche avec peu de villes.
Vous obtiendrez srement d'assez bons rsultats. Mais en est il autant avec beaucoup de villes?


CREDITS ET REFERENCES
---------------------

Cette applet a t dveloppe avec NetLogo par Aurlien SAINT-DIZIER pour le site www.interstices.info. L'algorithme original ainsi que les paramtres exprimentaux qui ont t utiliss pour dvelopper cette applet sont issus des travaux de Marco Dorigo, de l'Universit Libre de Bruxelles.
@#$#@#$#@
default
true
0
Polygon -7566196 true true 150 5 40 250 150 205 260 250

ant
true
0
Polygon -7566196 true true 136 61 129 46 144 30 119 45 124 60 114 82 97 37 132 10 93 36 111 84 127 105 172 105 189 84 208 35 171 11 202 35 204 37 186 82 177 60 180 44 159 32 170 44 165 60
Polygon -7566196 true true 150 95 135 103 139 117 125 149 137 180 135 196 150 204 166 195 161 180 174 150 158 116 164 102
Polygon -7566196 true true 149 186 128 197 114 232 134 270 149 282 166 270 185 232 171 195 149 186
Polygon -7566196 true true 225 66 230 107 159 122 161 127 234 111 236 106
Polygon -7566196 true true 78 58 99 116 139 123 137 128 95 119
Polygon -7566196 true true 48 103 90 147 129 147 130 151 86 151
Polygon -7566196 true true 65 224 92 171 134 160 135 164 95 175
Polygon -7566196 true true 235 222 210 170 163 162 161 166 208 174
Polygon -7566196 true true 249 107 211 147 168 147 168 150 213 150

arrow
true
0
Polygon -7566196 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

bee
true
0
Polygon -256 true false 152 149 77 163 67 195 67 211 74 234 85 252 100 264 116 276 134 286 151 300 167 285 182 278 206 260 220 242 226 218 226 195 222 166
Polygon -16777216 true false 150 149 128 151 114 151 98 145 80 122 80 103 81 83 95 67 117 58 141 54 151 53 177 55 195 66 207 82 211 94 211 116 204 139 189 149 171 152
Polygon -7566196 true true 151 54 119 59 96 60 81 50 78 39 87 25 103 18 115 23 121 13 150 1 180 14 189 23 197 17 210 19 222 30 222 44 212 57 192 58
Polygon -16777216 true false 70 185 74 171 223 172 224 186
Polygon -16777216 true false 67 211 71 226 224 226 225 211 67 211
Polygon -16777216 true false 91 257 106 269 195 269 211 255
Line -1 false 144 100 70 87
Line -1 false 70 87 45 87
Line -1 false 45 86 26 97
Line -1 false 26 96 22 115
Line -1 false 22 115 25 130
Line -1 false 26 131 37 141
Line -1 false 37 141 55 144
Line -1 false 55 143 143 101
Line -1 false 141 100 227 138
Line -1 false 227 138 241 137
Line -1 false 241 137 249 129
Line -1 false 249 129 254 110
Line -1 false 253 108 248 97
Line -1 false 249 95 235 82
Line -1 false 235 82 144 100

bird1
false
0
Polygon -7566196 true true 2 6 2 39 270 298 297 298 299 271 187 160 279 75 276 22 100 67 31 0

bird2
false
0
Polygon -7566196 true true 2 4 33 4 298 270 298 298 272 298 155 184 117 289 61 295 61 105 0 43

boat1
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 33 230 157 182 150 169 151 157 156
Polygon -7566196 true true 149 55 88 143 103 139 111 136 117 139 126 145 130 147 139 147 146 146 149 55

boat2
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 157 54 175 79 174 96 185 102 178 112 194 124 196 131 190 139 192 146 211 151 216 154 157 154
Polygon -7566196 true true 150 74 146 91 139 99 143 114 141 123 137 126 131 129 132 139 142 136 126 142 119 147 148 147

boat3
false
0
Polygon -1 true false 63 162 90 207 223 207 290 162
Rectangle -6524078 true false 150 32 157 162
Polygon -16776961 true false 150 34 131 49 145 47 147 48 149 49
Polygon -7566196 true true 158 37 172 45 188 59 202 79 217 109 220 130 218 147 204 156 158 156 161 142 170 123 170 102 169 88 165 62
Polygon -7566196 true true 149 66 142 78 139 96 141 111 146 139 148 147 110 147 113 131 118 106 126 71

box
true
0
Polygon -7566196 true true 45 255 255 255 255 45 45 45

butterfly1
true
0
Polygon -16777216 true false 151 76 138 91 138 284 150 296 162 286 162 91
Polygon -7566196 true true 164 106 184 79 205 61 236 48 259 53 279 86 287 119 289 158 278 177 256 182 164 181
Polygon -7566196 true true 136 110 119 82 110 71 85 61 59 48 36 56 17 88 6 115 2 147 15 178 134 178
Polygon -7566196 true true 46 181 28 227 50 255 77 273 112 283 135 274 135 180
Polygon -7566196 true true 165 185 254 184 272 224 255 251 236 267 191 283 164 276
Line -7566196 true 167 47 159 82
Line -7566196 true 136 47 145 81
Circle -7566196 true true 165 45 8
Circle -7566196 true true 134 45 6
Circle -7566196 true true 133 44 7
Circle -7566196 true true 133 43 8

circle
false
0
Circle -7566196 true true 35 35 230

person
false
0
Circle -7566196 true true 155 20 63
Rectangle -7566196 true true 158 79 217 164
Polygon -7566196 true true 158 81 110 129 131 143 158 109 165 110
Polygon -7566196 true true 216 83 267 123 248 143 215 107
Polygon -7566196 true true 167 163 145 234 183 234 183 163
Polygon -7566196 true true 195 163 195 233 227 233 206 159

sheep
false
15
Rectangle -1 true true 90 75 270 225
Circle -1 true true 15 75 150
Rectangle -16777216 true false 81 225 134 286
Rectangle -16777216 true false 180 225 238 285
Circle -16777216 true false 1 88 92

spacecraft
true
0
Polygon -7566196 true true 150 0 180 135 255 255 225 240 150 180 75 240 45 255 120 135

thin-arrow
true
0
Polygon -7566196 true true 150 0 0 150 120 150 120 293 180 293 180 150 300 150

truck-down
false
0
Polygon -7566196 true true 225 30 225 270 120 270 105 210 60 180 45 30 105 60 105 30
Polygon -8716033 true false 195 75 195 120 240 120 240 75
Polygon -8716033 true false 195 225 195 180 240 180 240 225

truck-left
false
0
Polygon -7566196 true true 120 135 225 135 225 210 75 210 75 165 105 165
Polygon -8716033 true false 90 210 105 225 120 210
Polygon -8716033 true false 180 210 195 225 210 210

truck-right
false
0
Polygon -7566196 true true 180 135 75 135 75 210 225 210 225 165 195 165
Polygon -8716033 true false 210 210 195 225 180 210
Polygon -8716033 true false 120 210 105 225 90 210

turtle
true
0
Polygon -7566196 true true 138 75 162 75 165 105 225 105 225 142 195 135 195 187 225 195 225 225 195 217 195 202 105 202 105 217 75 225 75 195 105 187 105 135 75 142 75 105 135 105

wolf
false
0
Rectangle -7566196 true true 15 105 105 165
Rectangle -7566196 true true 45 90 105 105
Polygon -7566196 true true 60 90 83 44 104 90
Polygon -16777216 true false 67 90 82 59 97 89
Rectangle -1 true false 48 93 59 105
Rectangle -16777216 true false 51 96 55 101
Rectangle -16777216 true false 0 121 15 135
Rectangle -16777216 true false 15 136 60 151
Polygon -1 true false 15 136 23 149 31 136
Polygon -1 true false 30 151 37 136 43 151
Rectangle -7566196 true true 105 120 263 195
Rectangle -7566196 true true 108 195 259 201
Rectangle -7566196 true true 114 201 252 210
Rectangle -7566196 true true 120 210 243 214
Rectangle -7566196 true true 115 114 255 120
Rectangle -7566196 true true 128 108 248 114
Rectangle -7566196 true true 150 105 225 108
Rectangle -7566196 true true 132 214 155 270
Rectangle -7566196 true true 110 260 132 270
Rectangle -7566196 true true 210 214 232 270
Rectangle -7566196 true true 189 260 210 270
Line -7566196 true 263 127 281 155
Line -7566196 true 281 155 281 192

wolf-left
false
3
Polygon -6524078 true true 117 97 91 74 66 74 60 85 36 85 38 92 44 97 62 97 81 117 84 134 92 147 109 152 136 144 174 144 174 103 143 103 134 97
Polygon -6524078 true true 87 80 79 55 76 79
Polygon -6524078 true true 81 75 70 58 73 82
Polygon -6524078 true true 99 131 76 152 76 163 96 182 104 182 109 173 102 167 99 173 87 159 104 140
Polygon -6524078 true true 107 138 107 186 98 190 99 196 112 196 115 190
Polygon -6524078 true true 116 140 114 189 105 137
Rectangle -6524078 true true 109 150 114 192
Rectangle -6524078 true true 111 143 116 191
Polygon -6524078 true true 168 106 184 98 205 98 218 115 218 137 186 164 196 176 195 194 178 195 178 183 188 183 169 164 173 144
Polygon -6524078 true true 207 140 200 163 206 175 207 192 193 189 192 177 198 176 185 150
Polygon -6524078 true true 214 134 203 168 192 148
Polygon -6524078 true true 204 151 203 176 193 148
Polygon -6524078 true true 207 103 221 98 236 101 243 115 243 128 256 142 239 143 233 133 225 115 214 114

wolf-right
false
3
Polygon -6524078 true true 170 127 200 93 231 93 237 103 262 103 261 113 253 119 231 119 215 143 213 160 208 173 189 187 169 190 154 190 126 180 106 171 72 171 73 126 122 126 144 123 159 123
Polygon -6524078 true true 201 99 214 69 215 99
Polygon -6524078 true true 207 98 223 71 220 101
Polygon -6524078 true true 184 172 189 234 203 238 203 246 187 247 180 239 171 180
Polygon -6524078 true true 197 174 204 220 218 224 219 234 201 232 195 225 179 179
Polygon -6524078 true true 78 167 95 187 95 208 79 220 92 234 98 235 100 249 81 246 76 241 61 212 65 195 52 170 45 150 44 128 55 121 69 121 81 135
Polygon -6524078 true true 48 143 58 141
Polygon -6524078 true true 46 136 68 137
Polygon -6524078 true true 45 129 35 142 37 159 53 192 47 210 62 238 80 237
Line -16777216 false 74 237 59 213
Line -16777216 false 59 213 59 212
Line -16777216 false 58 211 67 192
Polygon -6524078 true true 38 138 66 149
Polygon -6524078 true true 46 128 33 120 21 118 11 123 3 138 5 160 13 178 9 192 0 199 20 196 25 179 24 161 25 148 45 140
Polygon -6524078 true true 67 122 96 126 63 144

@#$#@#$#@
NetLogo 2.1beta2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
